diff -Naur valgrind-2.4.1-ppc/coregrind/ppc/Makefile.in valgrind-2.4.1-ppc.work/coregrind/ppc/Makefile.in
--- valgrind-2.4.1-ppc/coregrind/ppc/Makefile.in	2005-09-01 03:17:41.000000000 +0200
+++ valgrind-2.4.1-ppc.work/coregrind/ppc/Makefile.in	2006-03-26 17:31:24.000000000 +0200
@@ -487,7 +487,8 @@
 	$(CC) -Wl,--verbose -nostdlib 2>&1 | sed \
 		-e '1,/^=====\+$$/d' \
 		-e '/^=====\+$$/d' \
-		-e '/executable_start/s/0x[0-9a-f]\+/kickstart_base/g' > $@ \
+		-e 's/\(\. = \)0x[0-9a-f]\+\( + SIZEOF_HEADERS\)/\
+\1kickstart_base\2/g' > $@ \
 	  || rm -f $@
 
 # Generate offsets
diff -Naur valgrind-2.4.1-ppc/coregrind/vg_symtab2.c valgrind-2.4.1-ppc.work/coregrind/vg_symtab2.c
--- valgrind-2.4.1-ppc/coregrind/vg_symtab2.c	2005-03-11 07:28:10.000000000 +0100
+++ valgrind-2.4.1-ppc.work/coregrind/vg_symtab2.c	2006-03-26 17:31:24.000000000 +0200
@@ -1378,6 +1378,7 @@
       for (i = 0; i < ehdr->e_shnum; i++) {
 #        define FIND(sec_name, sec_data, sec_size, in_exec, type) \
          if (0 == VG_(strcmp)(sec_name, sh_strtab + shdr[i].sh_name)) { \
+            Bool nobits; \
             if (0 != sec_data) \
                VG_(core_panic)("repeated section!\n"); \
             if (in_exec) \
@@ -1385,9 +1386,11 @@
             else \
                sec_data = (type)(oimage + shdr[i].sh_offset); \
             sec_size = shdr[i].sh_size; \
+            nobits = shdr[i].sh_type == SHT_NOBITS; \
             TRACE_SYMTAB( "%18s: %p .. %p\n", \
                           sec_name, sec_data, sec_data + sec_size - 1); \
-            if ( shdr[i].sh_offset + sec_size > n_oimage ) { \
+            /* SHT_NOBITS sections have zero size in the file. */ \
+            if ( shdr[i].sh_offset + (nobits ? 0 : sec_size) > n_oimage ) { \
                VG_(symerr)("   section beyond image end?!"); \
                goto out; \
             } \
@@ -1449,13 +1452,16 @@
                for (i = 0; i < ehdr->e_shnum; i++) {
 #                 define FIND(sec_name, sec_data, sec_size, type) \
                   if (0 == VG_(strcmp)(sec_name, sh_strtab + shdr[i].sh_name)) { \
+                     Bool nobits; \
                      if (0 != sec_data) \
                         VG_(core_panic)("repeated section!\n"); \
                      sec_data = (type)(dimage + shdr[i].sh_offset); \
                      sec_size = shdr[i].sh_size; \
+                     nobits = shdr[i].sh_type == SHT_NOBITS; \
                      TRACE_SYMTAB( "%18s: %p .. %p\n", \
                                    sec_name, sec_data, sec_data + sec_size - 1); \
-                     if ( shdr[i].sh_offset + sec_size > n_dimage ) { \
+                     /* SHT_NOBITS sections have zero size in the file. */ \
+                     if ( shdr[i].sh_offset + (nobits ? 0 : sec_size) > n_dimage ) { \
                         VG_(symerr)("   section beyond image end?!"); \
                         goto out; \
                      } \
diff -Naur valgrind-2.4.1-ppc/glibc-2.3.supp valgrind-2.4.1-ppc.work/glibc-2.3.supp
--- valgrind-2.4.1-ppc/glibc-2.3.supp	2005-03-05 08:42:46.000000000 +0100
+++ valgrind-2.4.1-ppc.work/glibc-2.3.supp	2006-03-26 17:31:24.000000000 +0200
@@ -243,6 +243,28 @@
    Memcheck:Cond
    obj:/lib/ld-2.3.3.so
 }
+
+##----------------------------------------------------------------------##
+## ELDK 3.1.1 Linux 2.4.25
+{
+   Ugly strchr error in /lib/ld-2.3.1.so ?
+   Memcheck:Cond
+   obj:/lib/ld-2.3.1.so
+}
+
+{
+   Some more suppressions thanks to /lib/lbc-2.3.1.so
+   Memcheck:Cond
+   obj:/lib/libc-2.3.1.so
+}
+
+{
+   Some ioctl suppression in /lib/libc-2.3.1.so
+   Memcheck:Param
+   ioctl(generic)
+   obj:/lib/libc-2.3.1.so
+}
+
 ##----------------------------------------------------------------------##
 ## glibc-2.3.3 on FC2
 ## Assumes that sysctl returns \0-terminated strings in is_smp_system
